package com.abubusoft.kripton.android.sqlite;

import com.abubusoft.kripton.android.SQLiteModificationType;

/**
 * Rapresents operations generated by insert, update, delete operations on
 * tables.
 * 
 * In INSERT case, value is the id of the object.
 * 
 * In UPDATE, DELETE situation, it is the number of affected rows.
 * 
 * @author Francesco Benincasa (info@abubusoft.com)
 *
 */
public class SQLiteModification {

	public SQLiteModification(SQLiteModificationType operationType, long value) {
		this.operationType = operationType;
		this.value = value;
	}

	public final SQLiteModificationType operationType;
	public final long value;

	public static SQLiteModification createInsert(long result) {
		return new SQLiteModification(SQLiteModificationType.INSERT, result);
	}

	public static SQLiteModification createUpdate(long result) {
		return new SQLiteModification(SQLiteModificationType.UPDATE, result);
	}

	public static SQLiteModification createDelete(long result) {
		return new SQLiteModification(SQLiteModificationType.DELETE, result);
	}
}
